unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, HistoryList, StdCtrls, FileCtrl, ComCtrls, Registry;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    RecentFiles1: TMenuItem;
    HistoryList1: THistoryList;
    HistoryList2: THistoryList;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    DriveComboBox1: TDriveComboBox;
    Button1: TButton;
    Button2: TButton;
    MenuBookmarks: TMenuItem;
    Bookmarks1: TBookmarks;
    StatusBar1: TStatusBar;
    Button3: TButton;
    procedure AddClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Bookmarks1GetBookmark(Sender: TObject; var Bookmark,
      Name: String);
    procedure Bookmarks1Click(Sender: TObject; Filename: String);
    procedure Exit1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure HistoryListClick(Sender: TObject; Filename: String);
  private
    { Private declarations }
    dontsave:Boolean;
    procedure OnHint(Sender: TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//////////////////////// HistoryList ///////////////////////////////////////
procedure TForm1.AddClick(Sender: TObject);
begin
 if FileListBox1.FileName='' then
 begin
  ShowMessage('Please select a file first');
  exit;
 end;
 // second parameter of addFilename is ignored for Historylists
 if (Sender as TButton).Tag=1 then
  HistoryList1.addFilename(FileListBox1.FileName, '')
 else
  HistoryList2.addFilename(FileListBox1.FileName, '');
end;

procedure TForm1.HistoryListClick(Sender: TObject; Filename: String);
begin
 ShowMessage('You selected '+Filename);
end;

//////////////////////// Bookmarks ////////////////////////////////////////
procedure TForm1.Bookmarks1GetBookmark(Sender: TObject; var Bookmark,
  Name: String);
begin
 Bookmark:=DirectoryListBox1.Directory;
 Name:=ExtractFilename(Bookmark);
 if Name='' then
  Name:=Bookmark;
end;

procedure TForm1.Bookmarks1Click(Sender: TObject; Filename: String);
begin
 DirectoryListBox1.Directory:=Filename;
end;

//////////////////////// Window handling /////////////////////////////////
procedure TForm1.Exit1Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 Application.OnHint:=OnHint;
end;

procedure TForm1.OnHint(Sender: TObject);
begin
 StatusBar1.SimpleText:=Application.Hint;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if not dontsave then
 begin
  HistoryList1.saveToRegistry;
  HistoryList2.saveToRegistry;
  Bookmarks1.saveToRegistry;
 end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 with TRegistry.Create do
 try
  OpenKey('Software',false);
  DeleteKey(HistoryList1.RegPath+'\'+HistoryList1.RegKey);
  DeleteKey(HistoryList2.RegPath+'\'+HistoryList2.RegKey);
  DeleteKey(Bookmarks1.RegPath+'\'+Bookmarks1.RegKey);
 finally
  Free;
 end;
 dontsave:=true;
 ShowMessage('Restart to see changes.');
 Application.Terminate;
end;

end.
